# $Id: oracle-instantclient.spec 701 2007-01-23 21:38:06Z mike $

# Don't enable debuginfo package, what's left to strip shouldn't be!
%define debug_package %{nil}

# Define to use the basiclite source and create a basiclite package instead of
# the full-featured basic.
#define lite lite

%ifarch i386
%define ora_date -20060331
%define ora_arch linux32
%define odbc 1
%endif

%ifarch x86_64
%define ora_date -20060228
%define ora_arch linux-x86-64
%define odbc 1
%endif

%ifarch ppc
%define ora_date -20060327
%define ora_arch linuxppc32
%define odbc 0
%endif

%ifarch ppc64
%define ora_date -20060327
%define ora_arch linuxppc
%define odbc 0
%endif

# Use --define 'no64 1' on the command line to disable 64bit build
%{!?no64:%define BUILD64 1}
%{?no64:%define BUILD64 0}
%define prefix64 %{_prefix}/64

%if "%_os" == "aix" && %{BUILD64} == 0
%define ora_date -20060303
%define ora_arch aix32
%define odbc 0
%define __unzip %{_bindir}/unzip
%endif

%if "%_os" == "aix" && %{BUILD64} == 1
%define ora_date -20060303
%define ora_arch aix64
%define odbc 0
%define __unzip %{_bindir}/unzip
%define _64 64
%endif

%define ora_dir instantclient_10_2

Summary: Instant Client for Oracle Database 10g
Name: oracle-instantclient
Version: 10.2.0.2
Release: %RErelease 4
License: Oracle
Group: Applications/Databases
URL: http://www.oracle.com/technology/tech/oci/instantclient/instantclient.html
Source0: instantclient-basic%{?lite}-%{ora_arch}-%{version}%{?ora_date}.zip
Source1: instantclient-jdbc-%{ora_arch}-%{version}%{?ora_date}.zip
%{!?odbc:Source2: instantclient-odbc-%{ora_arch}-%{version}%{?ora_date}.zip}
Source3: instantclient-sdk-%{ora_arch}-%{version}%{?ora_date}.zip
Source4: instantclient-sqlplus-%{ora_arch}-%{version}%{?ora_date}.zip
NoSource: 0
NoSource: 1
%{!?odbc:NoSource: 2}
NoSource: 3
NoSource: 4
Source10: http://jeanchristophe.duber.free.fr/dbd_oracle_instantclient_linux/oracle-instantclient-config
BuildRoot: %{_tmppath}/%{name}%{?_64}-%{version}-%{release}-root
BuildRequires: rpm-macros-razorsedge
BuildRequires: perl, unzip
ExclusiveArch: i386 x86_64 ppc ppc64

%description
Instant Client for Oracle Database 10g.


%package basic%{?lite}%{?_64}
Summary: Instant Client for Oracle Database 10g
Group: Applications/Databases
%{?lite:Provides: %{name}-basic = %{version}-%{release}}
%{?_64:Provides: %{name}-basic = %{version}-%{release}}

%description basic%{?lite}%{?_64}
Base files for Instant Client which include support for OCI, OCCI, and JDBC-OCI
applications.


%package devel%{?_64}
Summary: Development headers for Instant Client
Group: Applications/Databases
Requires: %{name}-basic%{?_64} = %{version}
%{?_64:Provides: %{name}-devel = %{version}-%{release}}

%description devel%{?_64}
Additional header files and an example Makefile for developing Oracle
applications with Instant Client.


%package jdbc%{?_64}
Summary: Supplemental JDBC features under Instant Client
Group: Applications/Databases
Requires: %{name}-basic%{?_64} = %{version}
%{?_64:Provides: %{name}-jdbc = %{version}-%{release}}

%description jdbc%{?_64}
Additional support for XA, Internationalization, and RowSet operations under
JDBC in Instant Client.


%if %{?odbc:0}0
%package odbc%{?_64}
Summary: ODBC for Instant Client
Group: Applications/Databases
Requires: %{name}-basic%{?_64} = %{version}
%{?_64:Provides: %{name}-odbc = %{version}-%{release}}

%description odbc%{?_64}
Additional libraries for enabling ODBC support in Instant Client.
%endif


%package sqlplus%{?_64}
Summary: SQL*Plus for Instant Client
Group: Applications/Databases
Requires: %{name}-basic%{?_64} = %{version}
%{?_64:Provides: %{name}-sqlplus = %{version}-%{release}}

%description sqlplus%{?_64}
Additional libraries and executable for running SQL*Plus with Instant Client.


%prep
# AIX RPM does not know about unzip, so we have to simulate running %setup.
%if "%_os" == "aix"
cd $RPM_BUILD_DIR
%{__rm} -rf %{name}%{?_64}-%{version}
%{__mkdir} %{name}%{?_64}-%{version}
cd ${RPM_BUILD_DIR}/%{name}%{?_64}-%{version}

%{__unzip} -q %{SOURCE0}
STATUS=$?
if [ $STATUS -ne 0 ]; then
  exit $STATUS
fi
%{__unzip} -q %{SOURCE1}
STATUS=$?
if [ $STATUS -ne 0 ]; then
  exit $STATUS
fi
%{!?odbc:%{__unzip} -q %{SOURCE2}}
STATUS=$?
if [ $STATUS -ne 0 ]; then
  exit $STATUS
fi
%{__unzip} -q %{SOURCE3}
STATUS=$?
if [ $STATUS -ne 0 ]; then
  exit $STATUS
fi
%{__unzip} -q %{SOURCE4}
STATUS=$?
if [ $STATUS -ne 0 ]; then
  exit $STATUS
fi
[ `%{__id} -u` = '0' ] && %{__chown} -Rhf root .
[ `%{__id} -u` = '0' ] && %{__chgrp} -Rhf system .
%{__chmod} -Rf a+rX,g-w,o-w .
%else
%setup -c %{name}-%{version}
%setup -c %{name}-%{version} -D -T -a 1 -a 3 -a 4
%{!?odbc:%setup -c %{name}-%{version} -D -T -a 2}
%endif


%build


%install
%if "%_os" == "aix"
cd ${RPM_BUILD_DIR}/%{name}%{?_64}-%{version}
%endif
%{__rm} -rf %{buildroot}

# All the original Oracle files

%{__mkdir_p} %{buildroot}%{_bindir}
%{__mkdir_p} %{buildroot}%{_libdir}/oracle/%{version}/client/bin
%{__mkdir_p} %{buildroot}%{_libdir}/oracle/%{version}/client/%{_lib}
%{__mkdir_p} %{buildroot}%{_includedir}/oracle/%{version}/client/
%{__mkdir_p} %{buildroot}%{_datadir}/oracle/%{version}/client/

# basic/jdbc/odbc/sqlplus
%{__cp} -a %{ora_dir}/{*.so*,*.jar,*.sql} \
    %{buildroot}%{_libdir}/oracle/%{version}/client/%{_lib}/
%if "%_os" == "aix"
%{__cp} -a %{ora_dir}/*.a \
    %{buildroot}%{_libdir}/oracle/%{version}/client/%{_lib}/
%endif
%{!?odbc:%{__cp} -a %{ora_dir}/odbc_install.sh %{buildroot}%{_libdir}/oracle/%{version}/client/bin/}
%{__cp} -a %{ora_dir}/sqlplus \
    %{buildroot}%{_libdir}/oracle/%{version}/client/bin/
%{__ln_s} %{_libdir}/oracle/%{version}/client/bin/sqlplus \
    %{buildroot}%{_bindir}/sqlplus

# devel (sdk)
%{__cp} -a %{ora_dir}/sdk/include/*.h \
    %{buildroot}%{_includedir}/oracle/%{version}/client/
%{__cp} -a %{ora_dir}/sdk/demo/* \
    %{buildroot}%{_datadir}/oracle/%{version}/client/
%if "%_os" == "linux"
for file in libclntsh.so libocci.so; do
    pushd %{buildroot}%{_libdir}/oracle/%{version}/client/%{_lib}
    %{__ln_s} ${file}.* ${file}
    popd
done
%endif

# All the custom files

%if "%_os" == "linux"
# Install the ld.so.conf.d entry for the libs to be found
%{__mkdir_p} %{buildroot}%{_sysconfdir}/ld.so.conf.d
cat > %{buildroot}%{_sysconfdir}/ld.so.conf.d/oracle-instantclient.conf << EOF
%{_libdir}/oracle/%{version}/client/%{_lib}
EOF
%endif

# Install the profile.d entry for the env. variable to be set
%{__mkdir_p} %{buildroot}%{_sysconfdir}/profile.d
cat > %{buildroot}%{_sysconfdir}/profile.d/oracle.sh << EOF
export ORACLE_HOME=%{_libdir}/oracle/%{version}/client
export TNS_ADMIN=%{_sysconfdir}
export NLS_LANG=AMERICAN_AMERICA.WE8ISO8859P1
%if "%_os" == "aix"
export LIBPATH=\$LIBPATH:%{_libdir}/oracle/%{version}/client/%{_lib}
%endif
EOF

# Install the config script, replace /opt with /usr, lib and version
%{__install} -D %{SOURCE10} %{buildroot}%{_bindir}/oracle-instantclient-config
%{__perl} -pi -e 's|^prefix=.*|prefix=%{_prefix}|g;
                  s|/lib|/%{_lib}|g;
%if "%_os" == "aix"
                  s|-lclntsh -lnnz10 -locci -lociei -locijdbc10|-lclntsh -locci|g;
%endif
                  s|^version=.*|version=%{version}|g' \
    %{buildroot}%{_bindir}/oracle-instantclient-config


%clean
%{__rm} -rf %{buildroot}
%if "%_os" == "aix"
%{__rm} -rf ${RPM_BUILD_DIR}/%{name}%{?_64}-%{version}
%endif


%if "%_os" == "linux"
%post basic%{?lite} -p /sbin/ldconfig

%postun basic%{?lite} -p /sbin/ldconfig

%post jdbc -p /sbin/ldconfig

%postun jdbc -p /sbin/ldconfig

%{!?odbc:%post odbc -p /sbin/ldconfig}

%{!?odbc:%postun odbc -p /sbin/ldconfig}

%post sqlplus -p /sbin/ldconfig

%postun sqlplus -p /sbin/ldconfig
%endif


%files basic%{?lite}%{?_64}
%defattr(-, root, root, 0755)
# Custom files
%if "%_os" == "linux"
%attr(0644, root, root) %config %{_sysconfdir}/ld.so.conf.d/oracle-instantclient.conf
%endif
%attr(0755, root, root) %config(noreplace) %{_sysconfdir}/profile.d/oracle.sh
%attr(0755, root, root) %{_bindir}/oracle-instantclient-config
%dir %{_libdir}/oracle/
%dir %{_libdir}/oracle/%{version}/
%dir %{_libdir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/%{version}/client/%{_lib}/
# Original Oracle files
%{_libdir}/oracle/%{version}/client/%{_lib}/classes12.jar
%if "%_os" == "linux"
%{_libdir}/oracle/%{version}/client/%{_lib}/libclntsh.so.*
%{_libdir}/oracle/%{version}/client/%{_lib}/libocci.so.*
%endif
%if "%_os" == "aix"
%{_libdir}/oracle/%{version}/client/%{_lib}/libclntsh.a
%{_libdir}/oracle/%{version}/client/%{_lib}/libocci.a
%endif
%{_libdir}/oracle/%{version}/client/%{_lib}/libnnz10.so
%{!?lite:%{_libdir}/oracle/%{version}/client/%{_lib}/libociei.so}
%{?lite:%{_libdir}/oracle/%{version}/client/%{_lib}/libociicus.so}
%{_libdir}/oracle/%{version}/client/%{_lib}/libocijdbc10.so
%{_libdir}/oracle/%{version}/client/%{_lib}/ojdbc14.jar

%files devel%{?_64}
%defattr(-, root, root, 0755)
# Custom files
%dir %{_includedir}/oracle/
%dir %{_includedir}/oracle/%{version}/
%dir %{_includedir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/
%dir %{_libdir}/oracle/%{version}/
%dir %{_libdir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/%{version}/client/%{_lib}/
%dir %{_datadir}/oracle/
%dir %{_datadir}/oracle/%{version}/
%dir %{_datadir}/oracle/%{version}/client/
# Original Oracle files
%{_includedir}/oracle/%{version}/client/*.h
%if "%_os" == "linux"
%{_libdir}/oracle/%{version}/client/%{_lib}/libclntsh.so
%{_libdir}/oracle/%{version}/client/%{_lib}/libocci.so
%endif
%{_datadir}/oracle/%{version}/client/*

%files jdbc%{?_64}
%defattr(-, root, root, 0755)
# Custom files
%dir %{_libdir}/oracle/
%dir %{_libdir}/oracle/%{version}/
%dir %{_libdir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/%{version}/client/%{_lib}/
# Original Oracle files
%{_libdir}/oracle/%{version}/client/%{_lib}/libheteroxa10.so
%{_libdir}/oracle/%{version}/client/%{_lib}/orai18n.jar

%if %{?odbc:0}0
%files odbc%{?_64}
%defattr(-, root, root, 0755)
# Custom files
%dir %{_libdir}/oracle/
%dir %{_libdir}/oracle/%{version}/
%dir %{_libdir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/%{version}/client/bin/
%dir %{_libdir}/oracle/%{version}/client/%{_lib}/
# Original Oracle files
%doc %{ora_dir}/ODBC*.htm*
%{_libdir}/oracle/%{version}/client/bin/odbc_install.sh
%{_libdir}/oracle/%{version}/client/%{_lib}/libsqora.so.*
%endif

%files sqlplus%{?_64}
%defattr(-, root, root, 0755)
# Custom files
%dir %{_libdir}/oracle/
%dir %{_libdir}/oracle/%{version}/
%dir %{_libdir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/%{version}/client/bin/
%dir %{_libdir}/oracle/%{version}/client/%{_lib}/
# Original Oracle files
%{_bindir}/sqlplus
%{_libdir}/oracle/%{version}/client/bin/sqlplus
%{_libdir}/oracle/%{version}/client/%{_lib}/glogin.sql
%{_libdir}/oracle/%{version}/client/%{_lib}/libsqlplus.so
%{_libdir}/oracle/%{version}/client/%{_lib}/libsqlplusic.so


%changelog
* Mon Jan 22 2007 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 10.2.0.2-4
- Added option to build 32 or 64 bit on AIX.

* Fri Jan 19 2007 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 10.2.0.2-3
- Fixed to package on AIX.
- Fixed to package on Linux PPC.

* Wed May 17 2006 Matthias Saou <http://freshrpms.net/> 10.2.0.2-2
- Replace lib with lib64 on 64bit archs in oracle-instantclient-config (thanks
  to Mindaugas Riauba).

* Mon Apr 24 2006 Matthias Saou <http://freshrpms.net/> 10.2.0.2-1
- Update to 10.2.0.2.

* Fri Nov 18 2005 Matthias Saou <http://freshrpms.net/> 10.2.0.1-7
- Substitute hardcoded version= in oracle-instantclient-config (Stefan Radman).

* Tue Nov 15 2005 Matthias Saou <http://freshrpms.net/> 10.2.0.1-6
- Clean the spec file a bit since we now have the same version for both archs.
- Add ODBC sub-package (Stefan Radman).
- Minor cleanups (Stefan Radman).
- Checked Oracle rpm packages for 10.2.0.1... still badly broken :-(
- Add optional define to use basiclite libraries instead of the full basic
  (you just get a libociicus instead of libociei) - Untested, but should work.

* Thu Nov 10 2005 Matthias Saou <http://freshrpms.net/> 10.2.0.1-5
- Update x86_64 to newly released 10.2.0.1.

* Fri Jul 22 2005 Matthias Saou <http://freshrpms.net/> 10.1.0.3-4
- Add missing ldconfig calls for the jdbc and sqlplus packages.
- Add default export NLS_LANG=AMERICAN_AMERICA.WE8ISO8859P1 to oracle.sh.
- Update i386 to 10.2.0.1-20050713.
- Remove libocci10_296.so.10.1 entirely, it's gone from 10.2.0.1 i386 now.

* Mon Apr 11 2005 Matthias Saou <http://freshrpms.net/> 10.1.0.3-3
- Exclude libocci10_296.so.10.1 only for i386 as it's not present for x86_64.
- Create a lib -> lib64 when libs are in lib64 for libsqlora8 to detect libs.

* Fri Apr  8 2005 Matthias Saou <http://freshrpms.net/> 10.1.0.3-3
- Initial RPM release.

